// ---------------------------------------------------------------------------
//
// Cons3Main.CPP                                        Ulrich Mller 08.05.08
//                                                      PCS1700       VC++ 6.0
// Konsolprogramm mit FtLib_Static_LIBCMTD_Debug.lib und FtLib.h 
// zum Test der FtLib-Funktionen.
// Achtung : Men Projekt | Einstellungen | C/C++ | Kategorie Code Generation |
//           Laufzeit Bibliothek : Multithread debuggen.
//
// Lampen an O1 und O2, Endtaster an I1, Photowiderstand an AX
// -> DistanceSensor an D1 
// Firmwarestand : v1.75.0.04. FtLib v1.66 vom 18.08.07
//
// ----------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include "FtLib.h"

char  Ende;
DWORD res;
FT_HANDLE usbHandle;
UINT anzDev;
FT_TRANSFER_AREA* ftDCB;

void main()
{
	cout      << "--- Cons3 gestartet ---" << endl;
	res       = InitFtLib();
	cout      << "Version :    " << GetLibVersion() << endl;
	cout      << "Init :       " << res << endl;
	res       = InitFtUsbDeviceList();
	anzDev    = GetNumFtUsbDevice();
  usbHandle = GetFtUsbDeviceHandle(0);
	cout      << "DeviceTyp    " << GetFtDeviceTyp(usbHandle)        << endl;
	cout      << "SerialNr     " << GetFtSerialNrStrg(usbHandle)     << endl;
	cout      << "Firmware     " << GetFtFirmwareStrg(usbHandle)     << endl;
	cout      << "Manufacturer " << GetFtManufacturerStrg(usbHandle) << endl;
	cout      << "ShortName    " << GetFtShortNameStrg(usbHandle)    << endl;
	cout      << "LongName     " << GetFtLongNameStrg(usbHandle)     << endl;
	cout      << "OpenUSB      " << OpenFtUsbDevice(usbHandle)       << endl;

	res       = SetFtDistanceSensorMode(usbHandle, IF_DS_INPUT_ULTRASONIC, 0,0,0,0,0,0);

	res       = StartFtTransferArea(usbHandle, NULL);
	ftDCB     = GetFtTransferAreaAddress(usbHandle);

	cout      << "--- Action : I1 druecken ----" << endl;
	while ((ftDCB->E_Main & 0x1) == 0) {Sleep(123);}
	ftDCB->MPWM_Main[0] = 0x07;          // --- O1 mit full Power
	ftDCB->MPWM_Main[1] = 0x04;          // --- O2 mit halber Kraft
	for (int i = 0; i <2; i++) {         // --- Schleife Blinken
		ftDCB->M_Main = 0x01;
		Sleep(333);
		ftDCB->M_Main = 0x02;
		Sleep(333);
	}
	ftDCB->M_Main = 0x00;
	cout << "Akueller Wert AX     : " << ftDCB->AX << endl;
  cout << "DistanceValue        : " << ftDCB->D1 << endl;
	res  = StopFtTransferArea(usbHandle);
	res  = CloseFtDevice(usbHandle);
	res  = CloseFtLib();
	cout << "--- FINIS ---" << endl;
	cin.get(Ende);
}