// ---------------------------------------------------------------------------------
//
// Explorer2.C                                                Ulrich Mller 14.05.08
//                                                            PCS1700      Renesas C
// ROBO Explorer - Explorer 2 : Fahren auf Spur, dabei Hindernissen ausweichen.
//
// ---------------------------------------------------------------------------------

#include "RoboFish\roboFish.h"

#define mLinks           2
#define mRechts          1

#define cVor             1
#define cRuck            2
#define cOff             0

#define iImpulsLinks     1
#define iSpurLinks       3
#define iSpurRechts      4
#define dUltra           1


void Stopp(void){
  SetMotor(mLinks, ftiOff);
  SetMotor(mRechts, ftiOff);
}
void StoppR(void){
  SetMotor(mLinks, cVor);
  SetMotor(mRechts, ftiOff);
}
void StoppL(void){
  SetMotor(mLinks, ftiOff);
  SetMotor(mRechts, cVor);
}
void Vorwarts(void){
  SetMotor(mLinks, cVor, 4);
  SetMotor(mRechts, cVor, 4);
}
void Ruckwarts(void){
  SetMotor(mLinks, cRuck, 4);
  SetMotor(mRechts, cRuck, 4);
}
void Links(void){
  SetMotor(mLinks, cRuck, 4);
  SetMotor(mRechts, cVor, 4);
}
BOOL Hindernis(void){
// Wenn Entfernung zu einem Hindernis grer 12 cm Return
// sonst rckwrts bis Entfernung grer 13 und dann 0,5 Sek. Links Drehen
  if(GetDistanceValue(dUltra) >= 12) return TRUE;
  Stopp();
  Pause(1000);
  Ruckwarts();
  while(GetDistanceValue(dUltra) <=13) Pause(123);
  Stopp();
  Links();
  Pause(500);
  return FALSE;
}
void Spursuche(void){
// Wenn ein Spursensor auf Spur : Return
// Sonst endlos Suche 52 DoppelImpulse Linksdrehen 
// und dann 10 DoppelImpulse Vorwrtsfahren.
  UINT Zahler;
  do{
    Zahler = 52;
    Links();
    do{
      if(!GetInput(iSpurLinks) || !GetInput(iSpurRechts)){Stopp(); return;}
      WaitForHigh(iImpulsLinks);
      if(Hindernis()) Zahler = 52; Zahler--;
      Zahler--;
    } while(Zahler);
    Zahler = 10;
    Vorwarts();
    do{
      if(!GetInput(iSpurLinks) || !GetInput(iSpurRechts)){Stopp(); return;}
      WaitForHigh(iImpulsLinks);
      if(Hindernis()) Zahler = 0; Zahler--;
      Zahler--;
    } while(Zahler);
  } while(!Finish(6));
}

UCHAR main(void){
// EndlosLoop mit Auswertung der Spursensorwerte
  InitFish(FALSE, ftiDisUltra);
  Pause(1000);

  do{
    switch(GetInputs() & 0xC){                   // Spursensor an I3 und I4
      case 0xC: Stopp();    Spursuche(); break;  // beide von Spur
      case 0x8: StoppL();   Hindernis(); break;  // I4 nicht auf Spur
      case 0x4: StoppR();   Hindernis(); break;  // I3 nicht auf Spur
      default:  Vorwarts(); Hindernis();         // beide auf Spur
    }
  } while (!Finish(6));

  return(0);
}