// ---------------------------------------------------------------------------------
//
// roboFish.h                                                 Ulrich Mller 12.05.08
//                                                            PCS1700 Renesas C 4.00
// Deklarationen zu roboFish.c
//
// ---------------------------------------------------------------------------------

#include "..\TA_Firmware\TAF_00D.h";
#include "..\TA_Firmware\TAF_00P.h";
#include "..\Message\Msg_00D.h";
#include "..\Message\Msg_00P.h";

#define ftiAus      0
#define ftiOff      0
#define ftiEin      1
#define ftiOn       1
#define ftiLinks    1
#define ftiLeft     1
#define ftiRechts   2
#define ftiRight    2
#define ftiDisOff   0
#define ftiDisUltra 1
#define ftiDisVolt  0

void  InitFish(BOOL rf = FALSE, UINT DistanceMode = ftiDisVolt);
void  FinishFish();

void  ClearCounter(UCHAR InputNr);
void  ClearCounters();
void  ClearMessagesIn();
void  ClearMessagesOut();
void  ClearMotors();
BOOL  Finish(UCHAR InputNr = 0);
BOOL  FinishIR(UCHAR IRCode, UCHAR IRKey);
UINT  GetAnalog(UCHAR AnalogNr);
UINT  GetCounter(UCHAR InputNr);
UINT  GetDistanceValue(UCHAR DisNr);
BOOL  GetInput(UCHAR InputNr);
UCHAR GetInputs();
BOOL  GetIRKey(UCHAR IRCode, UCHAR IRKey);
UCHAR GetRFMessage(SMESSAGE* mData);
UINT  GetVoltage(UCHAR VoltNr);
BOOL  IsRFMessage();
UCHAR Outputs();
void  Pause(UINT mSek);
UCHAR SendRFMessage(SMESSAGE* mData, UCHAR Spez = 0);
void  SetCounter(UCHAR InputNr, UINT Value);
void  SetLamp(UCHAR LampNr, BOOL OnOff, UCHAR Power = 8);
void  SetMotor(UCHAR MotorNr, UCHAR Dir, UCHAR Speed = 8);
void  SetMotors(UCHAR MotorStatus, UINT SpeedStatus = 0x7777, UINT ModeStatus = 0);
void  SetRobMotor(UCHAR MotorNr, UCHAR Dir, UCHAR Speed, UINT Counter);
void  WaitForChange(UCHAR InputNr, UINT NrOfChanges, UCHAR TermNr = 0);
void  WaitForHigh(UCHAR InputNr);
void  WaitForInput(UCHAR InputNr, BOOL OnOff = TRUE);
void  WaitForIR(UCHAR IRCode, UCHAR IRKey, BOOL OnOff = TRUE);
void  WaitForLow(UCHAR InputNr);
UCHAR WaitForRFMessage(UINT mSek, SMESSAGE* mData);
UCHAR WaitForRobMotors(UINT mSek, UCHAR M1, UCHAR M2 = 0, UCHAR M3 = 0, UCHAR M4 = 0);
int   WaitForPositionDown(UCHAR InputNr, int Counter, int Position, UCHAR TermNr = 0);
int   WaitForPositionUp(UCHAR InputNr, int Counter, int Position, UCHAR TermNr = 0);
void  WaitForTime(UINT mSek);

