﻿// --------------------------------------------------------------------------------------
//
// UltraMain.cs                                                   Ulrich Müller  09.05.08
//                                                                PCS1700 C# 2005 Express
// Abtasten der Umgebung mit dem AbstandsSensor an D1
// Motor an M1 mit Endtaster an I1 und Impulstaster an I2
//   Basis ist die Assembly FishFace2005.DLL v4.375.2005 / umFish40.DLL v4.3.75.0
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace PhotoSensor {
  public partial class PhotoSensor : Form {
    FishFace ft = new FishFace();
    Graphics gw;
    Pen stift = new Pen(Color.Blue,3);
    Point von;

    private void Action() {
      gw = picAusgabe.CreateGraphics();
      lblStatus.Text = "Es geht nach Hause";
      ft.SetMotor(Out.M1, Dir.Left);
      ft.WaitForInput(Inp.I1);
      do {
        ft.SetMotor(Out.M1, Dir.Right, Speed.Full, 180);
        gw.Clear(Color.White);
        von = new Point(0, 127);
        do { AktuelleWerte(); } while (ft.WaitForMotors(250, 1) == Wait.Time);
        ft.SetMotor(Out.M1, Dir.Off);
        ft.Pause(1234);
        ft.SetMotor(Out.M1, Dir.Left, Speed.Full, 200);
        gw.Clear(Color.White);
        von = new Point(0, 0);
        do { AktuelleWerte(); } while (ft.WaitForMotors(250, 1) == Wait.Time);
        ft.SetMotor(Out.M1, Dir.Off);
        ft.Pause(1234);
      } while (!ft.Finish());
    }

    private void AktuelleWerte() {
      int Position, Abstand;
      Position = ft.GetCounter(Inp.I2);
      Abstand = ft.GetDistance(Inp.D1);
      Point nach = new Point(180-Position, (int)(256-Abstand));
      lblStatus.Text = "Position : " + (180-Position).ToString() + 
        " <-> Wert : " + Abstand.ToString();
      gw.DrawLine(stift, von, nach);
      von = nach;
      Application.DoEvents();
    }

    #region --- Programm-Kontrolle ---
    public PhotoSensor() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0, Distance.UltraSonic);
        fishPanel1.Start(ft);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        fishPanel1.Stop();
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}