﻿// -------------------------------------------------------------------------------------
//
// UltraMain.cs                                                  Ulrich Müller  08.05.08
//                                                               PCS1700 C# 2005 Express
// Testprogramm für den (UltraSonic) Abstandssensor an D1 des ROBO Interface
//   Die Anzeige der Werte erfolgt auf dem FishPanel bei D1
//       Zusätzlich Lampe an M1
// Mit FishFace2005.DLL v4.3.75.2005 und umFish40.DLL v4.3.75.0
//
// --------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace UltraTest {
  public partial class UltraMain : Form {
    FishFace ft = new FishFace();
    public UltraMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0, Distance.UltraSonic);
        fishPanel.Start(ft);
        do {
          ft.SetMotor(Out.M1, Dir.Ein);
          ft.Pause(333);
          ft.SetMotor(Out.M1, Dir.Aus);
          ft.Pause(333);
        } while (!ft.Finish());
        fishPanel.Stop();
        ft.CloseInterface();
        this.Close();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message);
        return;
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      ft.NotHalt = true;
      this.Close();
    }
  }
}