// -----------------------------------------------------------------------------
//
// umFish40VC.H                                           Ulrich Mller 08.05.08
//                                                        PCS1700       VC++ 6.0
// Deklarationen und Definitionen fr den Einsatz von umFish40.DLL
// 19.3.06 : Version 4.1 Mit Communication zwischen RF Datalink und zugeordnetem
//           ROBO Interface RF 2/1 und weiteren RF 2/2 ....
// 23.4.06 : FtLib v0.59
// 08.5.08 : UltraSonic FtLib v1.70a 
//
// -----------------------------------------------------------------------------

#include <Windows.h>

#define rbFehler 0xE0000001L

typedef struct {
	BYTE HwId;
	BYTE SubId;
	USHORT MsgId;
	USHORT Msg;
} MessageData;

int __stdcall rbOpenInterfaceUSB(int ifTyp, int SerialNr);
int __stdcall rbOpenInterfaceUSBdis(int ifTyp, int SerialNr, int DistanceMode); 
int __stdcall rbOpenInterfaceRF(int SerialNrInterface);
int __stdcall rbOpenInterfaceRFdis(int SerialNrInterface, int DistanceMode);
int __stdcall rbOpenInterfaceCOM(int ifTyp, int ComNr, int AnalogZyklen);
int __stdcall rbCloseInterface(int iHandle);

int __stdcall rbGetInput(int iHandle, int InputNr);
int __stdcall rbGetInputs(int iHandle);
int __stdcall rbGetAnalog(int iHandle, int AnalogNr);
int __stdcall rbGetIRKey(int Handle, int Code, int KeyNr);
int __stdcall rbGetVoltage(int iHandle, int VoltNr);

int __stdcall rbSetMotor(int iHandle, int MotNr, int Dir);
int __stdcall rbSetMotorEx(int iHandle, int MotNr, int Dir, int Speed);
int __stdcall rbGetMotors(int iHandle);
int __stdcall rbSetMotors(int iHandle, int MotorStatus);
int __stdcall rbSetMotorsEx(int iHandle, int MotorStatus, 
														int SpeedStatus, int SpeedStatus16);
int __stdcall rbGetModeStatus(int iHandle, int MotNr);
int __stdcall rbSetModeStatus(int iHandle, int MotNr, int Mode);
int __stdcall rbSetLamp(int iHandle, int LampNr, int OnOff);
int __stdcall rbSetLampEx(int iHandle, int LampNr, int OnOff, int Power);
int __stdcall rbRobMotor(int iHandle, int MotNr, int Dir, int Speed, int ICount);
int __stdcall rbRobMotors(int iHandle, int MotorStatus, 
													int SpeedStatus, int SpeedStatus16, int ModeStatus);

int __stdcall rbGetCounter(int iHandle, int CounterNr);
int __stdcall rbSetCounter(int iHandle, int CounterNr, int ICount);
int __stdcall rbClearCounters(int iHandle);

int    __stdcall rbClearMessagesIn(int Handle);
int    __stdcall rbClearMessagesOut(int iHandle);
int    __stdcall rbGetMessage(int iHandle, MessageData* inN);
int    __stdcall rbIsMessage(int iHandle);
int    __stdcall rbSendMessage(int iHandle, MessageData* outN);
int    __stdcall rbSendMessageEx(int iHandle, MessageData* outN, int Spez);

int    __stdcall rbGetDistanceValue(int iHandle, int SensorNr);

int    __stdcall rbGetActDeviceType(int iHandle);
int    __stdcall rbGetActDeviceSerialNr(int iHandle);
int    __stdcall rbGetActDeviceFirmwareNr(int iHandle);
LPCSTR __stdcall rbGetActDeviceFirmware(int iHandle);
LPCSTR __stdcall rbGetActDeviceName(int iHandle);

#define ftiAus      0
#define ftiEin      1
#define ftiLinks    1
#define ftiRechts   2
#define ftiAX       1
#define ftiAY       2
#define ftiAXS1     3
#define ftiAXS2     4
#define ftiAXS3     5
#define ftiA1       1
#define ftiA2       2
#define ftiAV       3
#define ftiAZ       4
#define ftiD1V      5
#define ftiD2V      6
#define ftiD1       1
#define ftiD2       2
#define ftiDisOff   0
#define ftiDisUltra 1
#define ftiDisVolt  2
